/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of IPv4.xs. Do not edit this file, edit IPv4.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "IPv4.xs"
/* This piece of code is a wrapper around libiptc from netfilter/iptables
 * for managing rules and chains.
 */

/*
 * Author: Derrik Pates <dpates@dsdk12.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <libiptc/libiptc.h>
#include <errno.h>
#include "packer.h"
#include "unpacker.h"
#include "loader.h"
#include "maskgen.h"
#include "module_iface.h"

typedef iptc_handle_t* IPTables__IPv4__Table;

#line 48 "IPv4.c"

XS(XS_IPTables__IPv4_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4_init)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::init(tablename)");
    {
	char *	tablename = (char *)SvPV_nolen(ST(0));
#line 44 "IPv4.xs"
	iptc_handle_t	handle;
#line 60 "IPv4.c"
	IPTables__IPv4__Table	RETVAL;
#line 47 "IPv4.xs"
		handle = iptc_init(tablename);
		if(handle == NULL) {
			RETVAL = NULL;
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
		else {
			RETVAL = malloc(sizeof(iptc_handle_t));
			*RETVAL = handle;
			ipt_loader_setup();
		}
#line 75 "IPv4.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "IPTables::IPv4::Table", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_is_chain); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_is_chain)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::is_chain(self, chain)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 69 "IPv4.xs"
		RETVAL = iptc_is_chain(chain, *self);
#line 119 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_list_chains); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_list_chains)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::list_chains(self)");
    SP -= items;
    {
	IPTables__IPv4__Table	self;
#line 77 "IPv4.xs"
	char *			chain;
	SV *			sv;
	int				count = 0;
#line 139 "IPv4.c"

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");
#line 81 "IPv4.xs"
		sv = ST(0);
		chain = (char *)iptc_first_chain(self);
		while(chain) {
			count++;
			if (GIMME_V == G_ARRAY)
				XPUSHs(sv_2mortal(newSVpv(chain, 0)));
			chain = (char *)iptc_next_chain(self);
		}
		if (GIMME_V == G_SCALAR)
			XPUSHs(sv_2mortal(newSViv(count)));
#line 158 "IPv4.c"
	PUTBACK;
	return;
    }
}


XS(XS_IPTables__IPv4__Table_list_rules); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_list_rules)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::list_rules(self, chain)");
    SP -= items;
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
#line 97 "IPv4.xs"
	SV *					sv;
	int				count = 0;
#line 178 "IPv4.c"

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 100 "IPv4.xs"
		sv = ST(0);
		if(iptc_is_chain(chain, *self)) {
			struct ipt_entry *entry =
			    (struct ipt_entry *)iptc_first_rule(chain, self);
			while(entry) {
				count++;
				if (GIMME_V == G_ARRAY)
					XPUSHs(sv_2mortal(newRV_noinc((SV*)ipt_do_unpack(entry, self))));
				entry = (struct ipt_entry *)iptc_next_rule(entry, self);
			}
		}
		if (GIMME_V == G_SCALAR)
			XPUSHs(sv_2mortal(newSViv(count)));
#line 216 "IPv4.c"
	PUTBACK;
	return;
    }
}


XS(XS_IPTables__IPv4__Table_builtin); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_builtin)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::builtin(self, chain)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 119 "IPv4.xs"
		RETVAL = iptc_builtin(chain, *self);
#line 259 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_get_policy); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_get_policy)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::get_policy(self, chain)");
    SP -= items;
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
#line 128 "IPv4.xs"
	struct ipt_counters		counter;
	SV *					sv;
	char *					target;
	char *					temp;
#line 281 "IPv4.c"

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 133 "IPv4.xs"
		sv = ST(0);
		if((target = (char *)iptc_get_policy(chain, &counter, self))) {
			XPUSHs(sv_2mortal(newSVpv(target, 0)));
			asprintf(&temp, "%llu", counter.pcnt);
			XPUSHs(sv_2mortal(newSVpv(temp, 0)));
			free(temp);
			asprintf(&temp, "%llu", counter.bcnt);
			XPUSHs(sv_2mortal(newSVpv(temp, 0)));
			free(temp);
		}
		else {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 321 "IPv4.c"
	PUTBACK;
	return;
    }
}


XS(XS_IPTables__IPv4__Table_insert_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_insert_entry)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::insert_entry(self, chain, entry, rulenum)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	struct ipt_entry *	entry;
	unsigned int	rulenum = (unsigned int)SvUV(ST(3));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};

	if( SvROK(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVHV)) {
		if(!ipt_do_pack((HV *)SvRV(ST(2)), &entry, self))
			XSRETURN(FALSE);
	}
	else {
		SET_ERRSTR("entry must be hash ref");
		XSRETURN(FALSE);
	};
#line 156 "IPv4.xs"
		RETVAL = iptc_insert_entry(chain, entry, rulenum, self);
		free(entry);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 381 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_replace_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_replace_entry)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::replace_entry(self, chain, entry, rulenum)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	struct ipt_entry *	entry;
	unsigned int	rulenum = (unsigned int)SvUV(ST(3));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};

	if( SvROK(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVHV)) {
		if(!ipt_do_pack((HV *)SvRV(ST(2)), &entry, self))
			XSRETURN(FALSE);
	}
	else {
		SET_ERRSTR("entry must be hash ref");
		XSRETURN(FALSE);
	};
#line 173 "IPv4.xs"
		RETVAL = iptc_replace_entry(chain, entry, rulenum, self);
		free(entry);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 441 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_append_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_append_entry)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::append_entry(self, chain, entry)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	struct ipt_entry *	entry;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};

	if( SvROK(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVHV)) {
		if(!ipt_do_pack((HV *)SvRV(ST(2)), &entry, self))
			XSRETURN(FALSE);
	}
	else {
		SET_ERRSTR("entry must be hash ref");
		XSRETURN(FALSE);
	};
#line 189 "IPv4.xs"
		RETVAL = iptc_append_entry(chain, entry, self);
		free(entry);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 500 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_delete_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_delete_entry)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::delete_entry(self, chain, origfw)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	struct ipt_entry *	origfw;
#line 205 "IPv4.xs"
	unsigned char *			matchmask = NULL;
#line 519 "IPv4.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};

	if( SvROK(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVHV)) {
		if(!ipt_do_pack((HV *)SvRV(ST(2)), &origfw, self))
			XSRETURN(FALSE);
	}
	else {
		SET_ERRSTR("origfw must be hash ref");
		XSRETURN(FALSE);
	};
#line 207 "IPv4.xs"
		if((matchmask = ipt_gen_delmask(origfw))) {
			RETVAL = iptc_delete_entry(chain, origfw, matchmask, self);
			if(!RETVAL) {
				SET_ERRNUM(errno);
				SET_ERRSTR("%s", iptc_strerror(errno));
				SvIOK_on(ERROR_SV);
			}
		}
		else {
			SET_ERRSTR("Unable to generate matchmask");
			RETVAL = FALSE;
		}
		free(origfw);
		free(matchmask);
#line 569 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_delete_num_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_delete_num_entry)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::delete_num_entry(self, chain, rulenum)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	unsigned int	rulenum = (unsigned int)SvUV(ST(2));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 230 "IPv4.xs"
		RETVAL = iptc_delete_num_entry(chain, rulenum, self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 618 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_flush_entries); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_flush_entries)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::flush_entries(self, chain)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 244 "IPv4.xs"
		RETVAL = iptc_flush_entries(chain, self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 666 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_zero_entries); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_zero_entries)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::zero_entries(self, chain)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 258 "IPv4.xs"
		RETVAL = iptc_zero_entries(chain, self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 714 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_create_chain); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_create_chain)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::create_chain(self, chain)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 272 "IPv4.xs"
		RETVAL = iptc_create_chain(chain, self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 762 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_delete_chain); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_delete_chain)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::delete_chain(self, chain)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 286 "IPv4.xs"
		RETVAL = iptc_delete_chain(chain, self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 810 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_rename_chain); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_rename_chain)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::rename_chain(self, oldname, newname)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	oldname;
	ipt_chainlabel	newname;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("oldname name too long");
			XSRETURN(FALSE);
		}
		memset(oldname, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(oldname, temp, len);
	}
	else {
		SET_ERRSTR("oldname must be string");
		XSRETURN(FALSE);
	};

	if( SvPOK(ST(2)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(2), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("newname name too long");
			XSRETURN(FALSE);
		}
		memset(newname, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(newname, temp, len);
	}
	else {
		SET_ERRSTR("newname must be string");
		XSRETURN(FALSE);
	};
#line 301 "IPv4.xs"
		RETVAL = iptc_rename_chain(oldname, newname, self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 875 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_set_policy); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_set_policy)
{
    dXSARGS;
    if (items < 3 || items > 4)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::set_policy(self, chain, policy, count = NULL)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	ipt_chainlabel	policy;
	SV *	count;
#line 317 "IPv4.xs"
	struct ipt_counters *	counters = NULL;
	HV *					hash;
	SV *					sv;
	char *					h_key;
	int						h_keylen;
#line 899 "IPv4.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};

	if( SvPOK(ST(2)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(2), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("policy name too long");
			XSRETURN(FALSE);
		}
		memset(policy, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(policy, temp, len);
	}
	else {
		SET_ERRSTR("policy must be string");
		XSRETURN(FALSE);
	};

	if (items < 4)
	    count = NULL;
	else {
	    count = ST(3);
	}
#line 323 "IPv4.xs"
		RETVAL = TRUE;
		if(count) {
			if((SvTYPE(count) == SVt_RV) && (hash = (HV *)SvRV(count)) &&
							(SvTYPE(hash) == SVt_PVHV)) {
				hv_iterinit(hash);
				counters = malloc(sizeof(struct ipt_counters));
				while((sv = hv_iternextsv(hash, &h_key, (I32 *)&h_keylen))) {
					if(!strcmp(h_key, "pcnt")) {
						if(SvTYPE(sv) == SVt_IV)
							counters->pcnt = SvUV(sv);
						else if(SvPOK(sv))
							sscanf(SvPV_nolen(sv), "%Lu", &counters->pcnt);
						else {
							RETVAL = FALSE;
							SET_ERRSTR("pcnt field must be integer or string");
						}
					}
					else if(!strcmp(h_key, "bcnt")) {
						if(SvTYPE(sv) == SVt_IV)
							counters->bcnt = SvUV(sv);
						else if(SvPOK(sv))
							sscanf(SvPV_nolen(sv), "%Lu", &counters->bcnt);
						else {
							RETVAL = FALSE;
							SET_ERRSTR("bcnt field must be integer or string");
						}
					}
					else {
						RETVAL = FALSE;
						SET_ERRSTR("count hash must contain only bcnt and pcnt keys");
					}
				}
			}
			else {
				RETVAL = FALSE;
				SET_ERRSTR("count must be hash ref");
			}
		}
		if(RETVAL) {
			RETVAL = iptc_set_policy(chain, policy, counters, self);
			if(!RETVAL) {
				SET_ERRNUM(errno);
				SET_ERRSTR("%s", iptc_strerror(errno));
				SvIOK_on(ERROR_SV);
			}
		}
		if(counters)
			free(counters);
#line 996 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_get_references); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_get_references)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::get_references(self, chain)");
    {
	IPTables__IPv4__Table	self;
	ipt_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IPT_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IPT_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 379 "IPv4.xs"
		if(!iptc_get_references(&RETVAL, chain, self)) {
			RETVAL = -1;
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 1044 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_commit); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_commit)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::commit(self)");
    {
	IPTables__IPv4__Table	self;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv4::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv4::Table");
#line 392 "IPv4.xs"
		RETVAL = iptc_commit(self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", iptc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
		*self = NULL;

#line 1077 "IPv4.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv4__Table_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv4__Table_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: IPTables::IPv4::Table::DESTROY(self)");
    {
	IPTables__IPv4__Table	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv4__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not a reference");
#line 407 "IPv4.xs"
		if(self) {
			if(*self)
				iptc_free(self);
			free(self);
		}
		ipt_release_modules();
		/* vim: ts=4
		 */
#line 1108 "IPv4.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_IPTables__IPv4); /* prototype to pass -Wmissing-prototypes */
XS(boot_IPTables__IPv4)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXS("IPTables::IPv4::init", XS_IPTables__IPv4_init, file);
        newXS("IPTables::IPv4::Table::is_chain", XS_IPTables__IPv4__Table_is_chain, file);
        newXS("IPTables::IPv4::Table::list_chains", XS_IPTables__IPv4__Table_list_chains, file);
        newXS("IPTables::IPv4::Table::list_rules", XS_IPTables__IPv4__Table_list_rules, file);
        newXS("IPTables::IPv4::Table::builtin", XS_IPTables__IPv4__Table_builtin, file);
        newXS("IPTables::IPv4::Table::get_policy", XS_IPTables__IPv4__Table_get_policy, file);
        newXS("IPTables::IPv4::Table::insert_entry", XS_IPTables__IPv4__Table_insert_entry, file);
        newXS("IPTables::IPv4::Table::replace_entry", XS_IPTables__IPv4__Table_replace_entry, file);
        newXS("IPTables::IPv4::Table::append_entry", XS_IPTables__IPv4__Table_append_entry, file);
        newXS("IPTables::IPv4::Table::delete_entry", XS_IPTables__IPv4__Table_delete_entry, file);
        newXS("IPTables::IPv4::Table::delete_num_entry", XS_IPTables__IPv4__Table_delete_num_entry, file);
        newXS("IPTables::IPv4::Table::flush_entries", XS_IPTables__IPv4__Table_flush_entries, file);
        newXS("IPTables::IPv4::Table::zero_entries", XS_IPTables__IPv4__Table_zero_entries, file);
        newXS("IPTables::IPv4::Table::create_chain", XS_IPTables__IPv4__Table_create_chain, file);
        newXS("IPTables::IPv4::Table::delete_chain", XS_IPTables__IPv4__Table_delete_chain, file);
        newXS("IPTables::IPv4::Table::rename_chain", XS_IPTables__IPv4__Table_rename_chain, file);
        newXS("IPTables::IPv4::Table::set_policy", XS_IPTables__IPv4__Table_set_policy, file);
        newXS("IPTables::IPv4::Table::get_references", XS_IPTables__IPv4__Table_get_references, file);
        newXS("IPTables::IPv4::Table::commit", XS_IPTables__IPv4__Table_commit, file);
        newXS("IPTables::IPv4::Table::DESTROY", XS_IPTables__IPv4__Table_DESTROY, file);
    XSRETURN_YES;
}

