/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of IPv6.xs. Do not edit this file, edit IPv6.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "IPv6.xs"
/* This piece of code is a wrapper around libiptc from netfilter/ip6tables
 * for managing rules and chains.
 */

/*
 * Author: Derrik Pates <dpates@dsdk12.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define INET6

#include <libiptc/libip6tc.h>
#include <errno.h>
#include "packer.h"
#include "unpacker.h"
#include "loader.h"
#include "maskgen.h"
#include "module_iface.h"

typedef ip6tc_handle_t* IPTables__IPv6__Table;

#line 49 "IPv6.c"

XS(XS_IPTables__IPv6_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6_init)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::init(tablename)");
    {
	char *	tablename = (char *)SvPV_nolen(ST(0));
#line 45 "IPv6.xs"
	ip6tc_handle_t	handle;
#line 61 "IPv6.c"
	IPTables__IPv6__Table	RETVAL;
#line 48 "IPv6.xs"
		handle = ip6tc_init(tablename);
		if(handle == NULL) {
			RETVAL = NULL;
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
		else {
			RETVAL = malloc(sizeof(ip6tc_handle_t));
			*RETVAL = handle;
			ipt_loader_setup();
		}
#line 76 "IPv6.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "IPTables::IPv6::Table", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_is_chain); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_is_chain)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::is_chain(self, chain)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 70 "IPv6.xs"
		RETVAL = ip6tc_is_chain(chain, *self);
#line 120 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_list_chains); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_list_chains)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::list_chains(self)");
    SP -= items;
    {
	IPTables__IPv6__Table	self;
#line 78 "IPv6.xs"
	char *			chain;
	SV *			sv;
	int				count = 0;
#line 140 "IPv6.c"

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");
#line 82 "IPv6.xs"
		sv = ST(0);
		chain = (char *)ip6tc_first_chain(self);
		while(chain) {
			count++;
			if (GIMME_V == G_ARRAY)
				XPUSHs(sv_2mortal(newSVpv(chain, 0)));
			chain = (char *)ip6tc_next_chain(self);
		}
		if (GIMME_V == G_SCALAR)
			XPUSHs(sv_2mortal(newSViv(count)));
#line 159 "IPv6.c"
	PUTBACK;
	return;
    }
}


XS(XS_IPTables__IPv6__Table_list_rules); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_list_rules)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::list_rules(self, chain)");
    SP -= items;
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
#line 98 "IPv6.xs"
	SV *					sv;
	int				count = 0;
#line 179 "IPv6.c"

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 101 "IPv6.xs"
		sv = ST(0);
		if(ip6tc_is_chain(chain, *self)) {
			struct ip6t_entry *entry =
			    (struct ip6t_entry *)ip6tc_first_rule(chain, self);
			while(entry) {
				count++;
				if (GIMME_V == G_ARRAY)
					XPUSHs(sv_2mortal(newRV_noinc((SV*)ipt_do_unpack(entry, self))));
				entry = (struct ip6t_entry *)ip6tc_next_rule(entry, self);
			}
		}
		if (GIMME_V == G_SCALAR)
			XPUSHs(sv_2mortal(newSViv(count)));
#line 217 "IPv6.c"
	PUTBACK;
	return;
    }
}


XS(XS_IPTables__IPv6__Table_builtin); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_builtin)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::builtin(self, chain)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 120 "IPv6.xs"
		RETVAL = ip6tc_builtin(chain, *self);
#line 260 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_get_policy); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_get_policy)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::get_policy(self, chain)");
    SP -= items;
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
#line 129 "IPv6.xs"
	struct ip6t_counters	counter;
	SV *					sv;
	char *					target;
	char *					temp;
#line 282 "IPv6.c"

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 134 "IPv6.xs"
		sv = ST(0);
		if((target = (char *)ip6tc_get_policy(chain, &counter, self))) {
			XPUSHs(sv_2mortal(newSVpv(target, 0)));
			asprintf(&temp, "%llu", counter.pcnt);
			XPUSHs(sv_2mortal(newSVpv(temp, 0)));
			free(temp);
			asprintf(&temp, "%llu", counter.bcnt);
			XPUSHs(sv_2mortal(newSVpv(temp, 0)));
			free(temp);
		}
		else {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 322 "IPv6.c"
	PUTBACK;
	return;
    }
}


XS(XS_IPTables__IPv6__Table_insert_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_insert_entry)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::insert_entry(self, chain, entry, rulenum)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	struct ip6t_entry *	entry;
	unsigned int	rulenum = (unsigned int)SvUV(ST(3));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};

	if( SvROK(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVHV)) {
		if(!ipt_do_pack((HV *)SvRV(ST(2)), &entry, self))
			XSRETURN(FALSE);
	}
	else {
		SET_ERRSTR("entry must be hash ref");
		XSRETURN(FALSE);
	};
#line 157 "IPv6.xs"
		RETVAL = ip6tc_insert_entry(chain, entry, rulenum, self);
		free(entry);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 382 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_replace_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_replace_entry)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::replace_entry(self, chain, entry, rulenum)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	struct ip6t_entry *	entry;
	unsigned int	rulenum = (unsigned int)SvUV(ST(3));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};

	if( SvROK(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVHV)) {
		if(!ipt_do_pack((HV *)SvRV(ST(2)), &entry, self))
			XSRETURN(FALSE);
	}
	else {
		SET_ERRSTR("entry must be hash ref");
		XSRETURN(FALSE);
	};
#line 174 "IPv6.xs"
		RETVAL = ip6tc_replace_entry(chain, entry, rulenum, self);
		free(entry);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 442 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_append_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_append_entry)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::append_entry(self, chain, entry)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	struct ip6t_entry *	entry;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};

	if( SvROK(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVHV)) {
		if(!ipt_do_pack((HV *)SvRV(ST(2)), &entry, self))
			XSRETURN(FALSE);
	}
	else {
		SET_ERRSTR("entry must be hash ref");
		XSRETURN(FALSE);
	};
#line 190 "IPv6.xs"
		RETVAL = ip6tc_append_entry(chain, entry, self);
		free(entry);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 501 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_delete_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_delete_entry)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::delete_entry(self, chain, origfw)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	struct ip6t_entry *	origfw;
#line 206 "IPv6.xs"
	unsigned char *			matchmask = NULL;
#line 520 "IPv6.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};

	if( SvROK(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVHV)) {
		if(!ipt_do_pack((HV *)SvRV(ST(2)), &origfw, self))
			XSRETURN(FALSE);
	}
	else {
		SET_ERRSTR("origfw must be hash ref");
		XSRETURN(FALSE);
	};
#line 208 "IPv6.xs"
		if((matchmask = ipt_gen_delmask(origfw))) {
			RETVAL = ip6tc_delete_entry(chain, origfw, matchmask, self);
			if(!RETVAL) {
				SET_ERRNUM(errno);
				SET_ERRSTR("%s", ip6tc_strerror(errno));
				SvIOK_on(ERROR_SV);
			}
		}
		else {
			SET_ERRSTR("Unable to generate matchmask");
			RETVAL = FALSE;
		}
		free(origfw);
		free(matchmask);
#line 570 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_delete_num_entry); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_delete_num_entry)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::delete_num_entry(self, chain, rulenum)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	unsigned int	rulenum = (unsigned int)SvUV(ST(2));
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 231 "IPv6.xs"
		RETVAL = ip6tc_delete_num_entry(chain, rulenum, self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 619 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_flush_entries); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_flush_entries)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::flush_entries(self, chain)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 245 "IPv6.xs"
		RETVAL = ip6tc_flush_entries(chain, self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 667 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_zero_entries); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_zero_entries)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::zero_entries(self, chain)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 259 "IPv6.xs"
		RETVAL = ip6tc_zero_entries(chain, self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 715 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_create_chain); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_create_chain)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::create_chain(self, chain)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 273 "IPv6.xs"
		RETVAL = ip6tc_create_chain(chain, self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 763 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_delete_chain); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_delete_chain)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::delete_chain(self, chain)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 287 "IPv6.xs"
		RETVAL = ip6tc_delete_chain(chain, self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 811 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_rename_chain); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_rename_chain)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::rename_chain(self, oldname, newname)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	oldname;
	ip6t_chainlabel	newname;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("oldname name too long");
			XSRETURN(FALSE);
		}
		memset(oldname, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(oldname, temp, len);
	}
	else {
		SET_ERRSTR("oldname must be string");
		XSRETURN(FALSE);
	};

	if( SvPOK(ST(2)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(2), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("newname name too long");
			XSRETURN(FALSE);
		}
		memset(newname, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(newname, temp, len);
	}
	else {
		SET_ERRSTR("newname must be string");
		XSRETURN(FALSE);
	};
#line 302 "IPv6.xs"
		RETVAL = ip6tc_rename_chain(oldname, newname, self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 876 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_set_policy); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_set_policy)
{
    dXSARGS;
    if (items < 3 || items > 4)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::set_policy(self, chain, policy, count = NULL)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	ip6t_chainlabel	policy;
	SV *	count;
#line 318 "IPv6.xs"
	struct ip6t_counters *	counters = NULL;
	HV *					hash;
	SV *					sv;
	char *					h_key;
	int						h_keylen;
#line 900 "IPv6.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};

	if( SvPOK(ST(2)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(2), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("policy name too long");
			XSRETURN(FALSE);
		}
		memset(policy, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(policy, temp, len);
	}
	else {
		SET_ERRSTR("policy must be string");
		XSRETURN(FALSE);
	};

	if (items < 4)
	    count = NULL;
	else {
	    count = ST(3);
	}
#line 324 "IPv6.xs"
		RETVAL = TRUE;
		if(count) {
			if((SvTYPE(count) == SVt_RV) && (hash = (HV *)SvRV(count)) &&
							(SvTYPE(hash) == SVt_PVHV)) {
				hv_iterinit(hash);
				counters = malloc(sizeof(struct ip6t_counters));
				while((sv = hv_iternextsv(hash, &h_key, (I32 *)&h_keylen))) {
					if(!strcmp(h_key, "pcnt")) {
						if(SvTYPE(sv) == SVt_IV)
							counters->pcnt = SvUV(sv);
						else if(SvPOK(sv))
							sscanf(SvPV_nolen(sv), "%Lu", &counters->pcnt);
						else {
							RETVAL = FALSE;
							SET_ERRSTR("pcnt field must be integer or string");
						}
					}
					else if(!strcmp(h_key, "bcnt")) {
						if(SvTYPE(sv) == SVt_IV)
							counters->bcnt = SvUV(sv);
						else if(SvPOK(sv))
							sscanf(SvPV_nolen(sv), "%Lu", &counters->bcnt);
						else {
							RETVAL = FALSE;
							SET_ERRSTR("bcnt field must be integer or string");
						}
					}
					else {
						RETVAL = FALSE;
						SET_ERRSTR("count hash must contain only bcnt and pcnt keys");
					}
				}
			}
			else {
				RETVAL = FALSE;
				SET_ERRSTR("count must be hash ref");
			}
		}
		if(RETVAL) {
			RETVAL = ip6tc_set_policy(chain, policy, counters, self);
			if(!RETVAL) {
				SET_ERRNUM(errno);
				SET_ERRSTR("%s", ip6tc_strerror(errno));
				SvIOK_on(ERROR_SV);
			}
		}
		if(counters)
			free(counters);
#line 997 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_get_references); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_get_references)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::get_references(self, chain)");
    {
	IPTables__IPv6__Table	self;
	ip6t_chainlabel	chain;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");

	if( SvPOK(ST(1)) ) {
		char *temp;
		STRLEN len;
		temp = SvPV(ST(1), len);
		if (len > IP6T_FUNCTION_MAXNAMELEN) {
			SET_ERRSTR("chain name too long");
			XSRETURN(FALSE);
		}
		memset(chain, 0, IP6T_FUNCTION_MAXNAMELEN + 1);
		strncpy(chain, temp, len);
	}
	else {
		SET_ERRSTR("chain must be string");
		XSRETURN(FALSE);
	};
#line 380 "IPv6.xs"
		if(!ip6tc_get_references(&RETVAL, chain, self)) {
			RETVAL = -1;
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
#line 1045 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_commit); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_commit)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::commit(self)");
    {
	IPTables__IPv6__Table	self;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "IPTables::IPv6::Table")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type IPTables::IPv6::Table");
#line 393 "IPv6.xs"
		RETVAL = ip6tc_commit(self);
		if(!RETVAL) {
			SET_ERRNUM(errno);
			SET_ERRSTR("%s", ip6tc_strerror(errno));
			SvIOK_on(ERROR_SV);
		}
		*self = NULL;

#line 1078 "IPv6.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IPTables__IPv6__Table_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_IPTables__IPv6__Table_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: IPTables::IPv6::Table::DESTROY(self)");
    {
	IPTables__IPv6__Table	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(IPTables__IPv6__Table,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not a reference");
#line 408 "IPv6.xs"
		if(self) {
			if(*self)
				ip6tc_free(self);
			free(self);
		}
		ipt_release_modules();
		/* vim: ts=4
		 */
#line 1109 "IPv6.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_IPTables__IPv6); /* prototype to pass -Wmissing-prototypes */
XS(boot_IPTables__IPv6)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXS("IPTables::IPv6::init", XS_IPTables__IPv6_init, file);
        newXS("IPTables::IPv6::Table::is_chain", XS_IPTables__IPv6__Table_is_chain, file);
        newXS("IPTables::IPv6::Table::list_chains", XS_IPTables__IPv6__Table_list_chains, file);
        newXS("IPTables::IPv6::Table::list_rules", XS_IPTables__IPv6__Table_list_rules, file);
        newXS("IPTables::IPv6::Table::builtin", XS_IPTables__IPv6__Table_builtin, file);
        newXS("IPTables::IPv6::Table::get_policy", XS_IPTables__IPv6__Table_get_policy, file);
        newXS("IPTables::IPv6::Table::insert_entry", XS_IPTables__IPv6__Table_insert_entry, file);
        newXS("IPTables::IPv6::Table::replace_entry", XS_IPTables__IPv6__Table_replace_entry, file);
        newXS("IPTables::IPv6::Table::append_entry", XS_IPTables__IPv6__Table_append_entry, file);
        newXS("IPTables::IPv6::Table::delete_entry", XS_IPTables__IPv6__Table_delete_entry, file);
        newXS("IPTables::IPv6::Table::delete_num_entry", XS_IPTables__IPv6__Table_delete_num_entry, file);
        newXS("IPTables::IPv6::Table::flush_entries", XS_IPTables__IPv6__Table_flush_entries, file);
        newXS("IPTables::IPv6::Table::zero_entries", XS_IPTables__IPv6__Table_zero_entries, file);
        newXS("IPTables::IPv6::Table::create_chain", XS_IPTables__IPv6__Table_create_chain, file);
        newXS("IPTables::IPv6::Table::delete_chain", XS_IPTables__IPv6__Table_delete_chain, file);
        newXS("IPTables::IPv6::Table::rename_chain", XS_IPTables__IPv6__Table_rename_chain, file);
        newXS("IPTables::IPv6::Table::set_policy", XS_IPTables__IPv6__Table_set_policy, file);
        newXS("IPTables::IPv6::Table::get_references", XS_IPTables__IPv6__Table_get_references, file);
        newXS("IPTables::IPv6::Table::commit", XS_IPTables__IPv6__Table_commit, file);
        newXS("IPTables::IPv6::Table::DESTROY", XS_IPTables__IPv6__Table_DESTROY, file);
    XSRETURN_YES;
}

